#ifndef GGAP_HELP_H
#define GGAP_HELP_H

#include <moo/appwindow.h>
#include <moo/pimpl.h>
#include <QTextBrowser>
#include <QUrl>

namespace ggap {

class HelpViewPrivate;
class HelpView : public QTextBrowser {
    Q_OBJECT
    M_DECLARE_IMPL(HelpView)

public:
    HelpView(QWidget *parent = 0);
    ~HelpView();

    void setSource(const QUrl &url);
    void home();

    void applyPrefs();
    void setFontFromPrefs();

    virtual QVariant loadResource(int type, const QUrl &name);

private:
    QVariant checkLoadHtml(const QVariant &data, const QUrl &url);
    QVariant checkLoadCss(const QVariant &data, const QUrl &url);

public Q_SLOTS:
    void up();

Q_SIGNALS:
    void upAvailable(bool available);
};

class HelpBrowserPrivate;
class HelpBrowser : public moo::AppWindow {
public:
    static void showWindow(const QUrl &url = QUrl());

    static QString parseUrl(const QString &str);

protected:
    virtual void printDocument(QPrinter *printer);
    virtual void setupPrintDialog(QPrintDialog *dlg);

private:
    Q_OBJECT
    M_DECLARE_IMPL(HelpBrowser)

    HelpBrowser();
    ~HelpBrowser();

    HelpView *view();

    virtual void applyPrefs();

private Q_SLOTS:
    void openAddress(const QString &address);
    void viewSourceChanged(const QUrl &url);
    void on_actionAddBookmark_triggered();
    void on_actionGo_triggered();
    void on_actionZoomIn_triggered();
    void on_actionZoomOut_triggered();
    void on_actionZoomNormal_triggered();
};

}

#endif // GGAP_HELP_H
